/* I actually took the SphereInspector (including its nib file) and modified
*  it. The only real modification is the initialization of the SliderDualActing
*  used for the number of waves (the only variable not handled by the 
*  Quadric super class). My thanks to Andrew Stone for providing me with
*  this class and its documentation. By now it should be posted on the archives
*  Look for it.
*/


#import "3dreality_api.h"
#import "WaveInspector.h"
#import "Wave.h"

@implementation WaveInspector : QuadricInspector

// This method called at initialization.
- loadShape:(Shape *)shape inView:(Camera *)camera
{
    if (shape) {
	[super loadShape:shape inView:camera]; 

    [nWaveSlider setUpTarget:self action:@selector(changenWave:)];
    [nWaveSlider setAltStep:1 whole:YES default:1];
    [nWaveSlider setMax:10 allowHigher:YES min:1 allowLower:NO];
    [nWaveSlider setIntValue:4];

	if ([shape isKindOf:[Wave class]]) {
	    if (nWaveSlider)[nWaveSlider setIntValue:
	    		[(Wave *)shape nWaves]];
	}
    }
    return self;
}

- changenWave:sender
{
    Shape *shape = [self selectedShape];
    if (shape && [shape isKindOf:[Wave class]]) {
	RtInt value = [sender intValue];
	[(Wave*) shape setnWave:&value];
	[self displayChanges]; //Hope this is in the superclass
    }
    return self;
}


- setnWaveSlider:anObject	
{
    nWaveSlider = anObject;

    [anObject setUpTarget:self action:@selector(changenWave:)];
    [anObject setAltStep:1 whole:YES default:1];
    [anObject setMax:10 allowHigher:YES min:1 allowLower:NO];
    [anObject setIntValue:4];

    return self;
}


@end
